set serveroutput on 99999
set feedback on
set termout on
set echo on
set pagesize 1000
set linesize 200


 

clear screen

CREATE TYPE fi_number_nt AS TABLE OF NUMBER;
/
CREATE TYPE fi_varchar_nt AS TABLE OF varchar2(1500);
/

CREATE TABLE "MOVIE_PREFERENCES"
(
"ID" NUMBER (5) NOT NULL,
"AGE_CATEGORY" NUMBER (1) NOT NULL,
"GENDER" VARCHAR2 (1),
"MVE_ID_1" NUMBER (3) NOT NULL,
"MVE_ID_2" NUMBER,
"MVE_ID_3" NUMBER
)
;
CREATE TABLE "AGE_CATEGORIES"
(
"ID" NUMBER (1) NOT NULL,
"DESCRIPTION" VARCHAR2 (50)
)
;
CREATE TABLE "MOVIES"
(
"ID" NUMBER (3) NOT NULL,
"TITLE" VARCHAR2 (100)
)
;
ALTER TABLE "AGE_CATEGORIES"
ADD CONSTRAINT "AGE_CATEGORIES_PK1" PRIMARY KEY
(
"ID"
)
 ENABLE
;
ALTER TABLE "MOVIES"
ADD CONSTRAINT "MOVIES_PK" PRIMARY KEY
(
"ID"
)
 ENABLE
;
ALTER TABLE "MOVIE_PREFERENCES"
ADD CONSTRAINT "MPE_ACY_FK1" FOREIGN KEY
(
"AGE_CATEGORY"
)
REFERENCES "AGE_CATEGORIES"
(
"ID"
) ENABLE
;
ALTER TABLE "MOVIE_PREFERENCES"
ADD CONSTRAINT "MPE_MVE_FK1" FOREIGN KEY
(
"MVE_ID_1"
)
REFERENCES "MOVIES"
(
"ID"
) ENABLE
;
ALTER TABLE "MOVIE_PREFERENCES"
ADD CONSTRAINT "MPE_MVE_FK2" FOREIGN KEY
(
"MVE_ID_2"
)
REFERENCES "MOVIES"
(
"ID"
) ENABLE
;
ALTER TABLE "MOVIE_PREFERENCES"
ADD CONSTRAINT "MPE_MVE_FK3" FOREIGN KEY
(
"MVE_ID_3"
)
REFERENCES "MOVIES"
(
"ID"
) ENABLE
;
create or replace 
function present_items
( p_itemset in FI_NUMBER_NT
) return varchar2
is
  l_return_value varchar2(1000):='';
  l_help varchar2(100):='';

  procedure add(p_string in varchar2)
  is
  begin
    l_return_value:= l_return_value||p_string||', ';
  end add;

	

begin

  for i in 1..p_itemset.count loop
    if p_itemset(i) < 0
    then
      case p_itemset(i) when '-1' then add('Male'); else add('Female'); end case;
    elsif p_itemset(i) > 1000
    then
      select description
      into   l_help
      from   age_categories
      where  id = p_itemset(i)/1000
      ;
      add(l_help);
    else
      select title
      into   l_help
      from   movies
      where  id = p_itemset(i)
      ;
      add(l_help);
    end if;
  end loop;
  return substr(l_return_value, 1, length(l_return_value)-2);
end;  
/
create or replace 
function set_contains_item
( p_itemset in FI_varchar_NT
, p_value   in varchar2
) return number
is
begin
  for i in 1..p_itemset.count loop
    if p_itemset(i) = p_value
    then
      return 1;
    end if;
  end loop;
  return 0;
end;  
/


delete movies;
delete movie_preferences;
delete age_categories;

insert into age_categories
( id, description)
values (1,'2-6 years')
;
insert into age_categories
( id, description)
values (2,'7-12 years')
;
insert into age_categories
( id, description)
values (3,'12-15 years')
;
insert into age_categories
( id, description)
values (4,'16-21 years')
;
insert into age_categories
( id, description)
values (5,'21+ years')
;

insert into MOVIES
( "ID" , "TITLE")
values (1, 'Shrek 2')
;
insert into MOVIES
( "ID" , "TITLE")
values (2, 'Monster Inc')
;
insert into MOVIES
( "ID" , "TITLE")
values (3, 'Sharktale')
;
insert into MOVIES
( "ID" , "TITLE")
values (4, 'Bridget Jones - On the edge of reason')
;
insert into MOVIES
( "ID" , "TITLE")
values (5, 'Love Actually')
;
insert into MOVIES
( "ID" , "TITLE")
values (6, 'Dodgeball')
;
insert into MOVIES
( "ID" , "TITLE")
values (7, 'The Matrix Reloaded')
;
insert into MOVIES
( "ID" , "TITLE")
values (8, 'K3 en het betoverde medaillon')
;
insert into MOVIES
( "ID" , "TITLE")
values (9, 'Lord of The Rings')
;
insert into MOVIES
( "ID" , "TITLE")
values (10, 'Finding Nemo')
;

insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 1, 5 ,'M', 9, 7, 5  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 2, 5 ,'M', 9, 10, 2  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 3, 5 ,'M', 10, 7, 9  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 4, 4 ,'M', 6, 7, 9  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 5, 4 ,'M', 6, 7, 9  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 6, 4 ,'F', 4, 7, 9  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 7, 4 ,'F', 4, 3, 9  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 8, 4 ,'F', 4, 5, 6  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 9, 5 ,'F', 4, 5, 3  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 10, 5 ,'F', 4, 5, 3  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 11, 5 ,'F', 2, 5, 3  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 12, 5 ,'F', 10, 2, 3  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 13, 5 ,'F', 4, 5, 7  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 14, 1 ,'F', 8, 10, 2  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 15, 1 ,'F', 8, 10, 2  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 16, 1 ,'M', 3, 10, 2  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 17, 1 ,'M', 3, 10, 2  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 18, 1 ,'M', 3, 1, 2  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 19, 2 ,'M', 3, 1, 2  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 20, 2 ,'F', 3, 8, 1  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 21, 2 ,'F', 3, 8, 1  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 22, 3 ,'F', 10, 3, 1  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 23, 3 ,'F', 10, 3, 2  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 24, 3 ,'F', 10, 3, 1  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 25, 3 ,'M', 10, 3, 1  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 26, 3 ,'M', 10, 3, 6  )
;
insert into "MOVIE_PREFERENCES"
( "ID", "AGE_CATEGORY", "GENDER" , "MVE_ID_1"  , "MVE_ID_2"  , "MVE_ID_3" )
values 
( 27, 3 ,'M', 2, 3, 6  )
;

clear screen
select * from movies
/
select * from age_categories
/
select * from movie_preferences
/

rem now for the Movie Preferences from my Survey
rem Note: ridiculously few records to perform data mining on!!!
pause

select case mpe.gender
       when 'M' then 'Male'
       else 'Female'
       end Gender
,      cast(acy.description as varchar2(20)) age_category
,      cast(mve1.title as varchar2(25)) movie1
,      cast(mve2.title as varchar2(25)) movie2
,      cast(mve3.title as varchar2(25)) movie3
from   movie_preferences mpe
,      movies mve1
,      movies mve2
,      movies mve3
,      age_categories acy
where  mpe.mve_id_1 = mve1.id
and    mpe.mve_id_2 = mve2.id
and    mpe.mve_id_3 = mve3.id
and    acy.id = mpe.age_category
/
pause

SELECT CAST (itemset as FI_number_NT) itemset
,      support
,      length
,      total_tranx
FROM   table( DBMS_FREQUENT_ITEMSET.FI_TRANSACTIONAL
              (  cursor
                 ( SELECT id, mve_id_1 FROM movie_preferences mpe
                   union
                   SELECT id, mve_id_2 FROM movie_preferences mpe
                   union
                   SELECT id, mve_id_3 FROM movie_preferences mpe
                   union
                   SELECT id, 1000* age_category FROM movie_preferences mpe
                   union
                   SELECT id, case mpe.gender when 'M' then -1 else -2 end FROM movie_preferences mpe
                 )
              , 0.05
              , 4
              , 6
              , NULL
              , NULL
              )
            )    
order
by     support desc
,      length  desc

pause

/

pause

rem let's present the data mining results in a somewhat better way:


SELECT present_items( CAST (itemset as FI_number_NT)) itemset
,      support
,      length
,      total_tranx
FROM   table( DBMS_FREQUENT_ITEMSET.FI_TRANSACTIONAL
              (  cursor
                 ( SELECT id, mve_id_1 FROM movie_preferences mpe
                   union
                   SELECT id, mve_id_2 FROM movie_preferences mpe
                   union
                   SELECT id, mve_id_3 FROM movie_preferences mpe
                   union
                   SELECT id, 1000* age_category FROM movie_preferences mpe
                   union
                   SELECT id, case mpe.gender when 'M' then -1 else -2 end FROM movie_preferences mpe
                 )
              , 0.05
              , 4
              , 6
              , NULL
              , NULL
              )
            )
order
by     support desc
,      length  desc


pause
/

pause

clear screen

rem Now for our business case: what will my 5-year old nephew want to watch?
rem We know that: 1) he is male; 2) he is 5 year old 3) He liked Finding Nemo
rem The database knows what that can mean in terms of movie preferences

select distinct
       items.column_value "Recommended Movie"
from   ( SELECT CAST(itemset as FI_varchar_NT) itemset
         ,      support
         ,      length
         ,      total_tranx
         FROM   table ( DBMS_FREQUENT_ITEMSET.FI_TRANSACTIONAL
                        ( cursor
                          ( SELECT mpe.id, title FROM movie_preferences mpe, movies mve where mve.id = mpe.mve_id_1
                            union
                            SELECT mpe.id, title FROM movie_preferences mpe, movies mve where mve.id = mpe.mve_id_2
                            union
                            SELECT mpe.id, title FROM movie_preferences mpe, movies mve where mve.id = mpe.mve_id_3
                            union
                            SELECT mpe.id, acy.description FROM movie_preferences mpe, age_categories acy  where acy.id = mpe.age_category
                            union
                            SELECT mpe.id, mpe.gender FROM movie_preferences mpe
                          )
                        , 0.05 
                        , 4
                        , 6
                        , CURSOR( SELECT * FROM table(FI_VARCHAR_NT('Finding Nemo')))
                        , NULL
                        )
                      )
        ) it
,       table(it.itemset) items
,       movies mve
where support > 1     
and   set_contains_item( itemset, '2-6 years' ) = 1
and   set_contains_item( itemset, 'M' ) = 1
and   mve.title = items.column_value
and   mve.title != 'Finding Nemo'

pause
/


