connect scott/tiger

set feedback on
set termout on
set echo on
set pagesize 1000
set linesize 200
clear screen

select ename
,      deptno
,      sal
,      comm
,      total_sal
from   emp
model  main salary_model                            -- name of the model
dimension by (ename)                                -- names of the reference columns, used for reffering to cells
measures (sal, comm, 0 as total_sal, deptno )       -- names of the result columns; these can be created or updated or their values are used in calculations
                                                    -- any column not used for partioning or navigation should be a measure!
ignore nav                                          -- not available (for example when counting or averaging)
rules upsert                                        -- allow creation and update of cells; in this case, insert would have sufficed
( total_sal[ANY]= sal[CV(ename)] + comm[CV(ename)]) -- calculate the cell in the total_sal column 
                                                    -- from the values in the sal and comm columns for the same ename
 
pause
/
