connect scott/tiger

set feedback on
set termout on
set echo on
set pagesize 1000
set linesize 200
clear screen


rem Grand Total

select ename
,      total_sal
from   emp
model
  return updated rows                                   -- return only rows that have been touched (created or updated)
  main   salary_model
  dimension by ( ename )                                -- use ename for reference
  measures     (sal, comm, 0 as total_sal ) ignore nav  -- use sal, comm for calculation and introduce a new calculable column total_sal
  rules upsert                                          -- allow update and insert of existing and new cells
  ( total_sal['GRAND']= sum(sal)[ANY] + sum(comm)[ANY]  -- calculate a cell in a new row (where dimension ENAME = GRAND)
  )

pause
/

pause
clear screen

rem Grand Total - Partitioned by Department

select deptno
,      ename
,      total_sal
from   emp
model
  return updated rows
  main   salary_model
  partition by (deptno)
  dimension by ( ename )
  measures     (sal, nvl(comm,0) comm , 0 as total_sal )
  rules upsert
  ( total_sal['GRAND']= sum(sal)[ANY] + sum(comm)[ANY]
  )

pause
/
pause
