connect sh/sh

set feedback on
set termout on
set echo on
set pagesize 1000
set linesize 200

CREATE or replace VIEW sales_view AS
   SELECT country_name country, prod_name prod, calendar_year year,
          SUM(amount_sold) sale, COUNT(amount_sold) cnt
   FROM   sales, times, customers, countries, products
   WHERE  sales.time_id = times.time_id AND
          sales.prod_id = products.prod_id 
   AND    sales.cust_id = customers.cust_id
   AND    customers.country_id = countries.country_id
   GROUP BY country_name, prod_name, calendar_year
/
clear screen

select SUBSTR(country,1,20) country
,      SUBSTR(prod,1,15) prod
,      year
,      sale
from   sales_view
where  SUBSTR(prod,1,15) in ('Bounce','Y Box', '2_Products')
and    country IN ('Italy','Japan')
order
by     country, prod, year

pause
/
pause

SELECT SUBSTR(country,1,20) country
,      SUBSTR(prod,1,15) prod
,      year
,      sales
FROM   sales_view
WHERE  country IN ('Italy','Japan')
MODEL  RETURN UPDATED ROWS
PARTITION BY (country) -- for every country 
DIMENSION BY (prod, year) -- cells are referenced with these
MEASURES     (sale sales) -- the value to be derived
RULES (
sales['Bounce', 2002] = sales['Bounce', 2001] +
sales['Bounce', 2000],
sales['Y Box', 2002] = sales['Y Box', 2001],
sales['2_Products', 2002] = sales['Bounce', 2002] 
                            + sales['Y Box', 2002]
)
ORDER BY country, prod, year

pause
/

