connect scott/tiger

set feedback on
set termout on
set echo on
set pagesize 1000
set linesize 200
clear screen

rem generate rows out of thin aire

SELECT cell num
FROM   DUAL
MODEL
DIMENSION BY (0 attr)
MEASURES (0 cell)
RULES  ITERATE (10)
 ( cell[iteration_number]    = iteration_number)

pause
/

pause
clear screen

Rem Pivoting
rem step 1
select deptno
,      ename
,      row_number() OVER ( PARTITION BY deptno
                           ORDER BY sal desc NULLS LAST) rnk
from   emp
order
by     deptno
,      rnk
/

pause

clear screen

select deptno
,      nr1 
,      nr2
,      nr3
from   emp
model
  return updated rows
  partition by (deptno)                     -- do this thing for each Department
  dimension by (row_number() OVER (PARTITION BY deptno
                                   ORDER BY sal desc NULLS LAST) rnk
               )                            -- each position gets its own result column
  measures ( ename
           , cast('' as varchar2(10)) nr1   -- cast as varchar2(10) to ensure the new measure column is wide enough to hold the calculated value
           , cast('' as varchar2(10)) nr2
           , cast('' as varchar2(10)) nr3
           )                                -- prepare new measure columns nr1, nr2, nr3
  rules upsert
  (   nr1 [0] = ename [1]
    , nr2 [0] = ename [2]
    , nr3 [0] = ename [3]
  )
order 
by     deptno


pause
/
